// mPCIe_TTCAN_int.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include "windows.h"
#include "TTCANDeviceEx.h"

using namespace std;

bool testRegister_Interrupt(){
  TTCCANDeviceEx objEx;
  objEx.Open(0);
  wchar_t name[17] = L"MyInterruptEvent";

  HANDLE Event= CreateEvent(NULL, TRUE, FALSE, name);
  if (!Event){
	return FALSE;
  }

  UINT8 nCh=2;
  if (objEx.Register_Interrupt(nCh, RX0IE, Event) != 1){
	  cout<<"Register_Interrupt error"<<endl;
	  return FALSE;
  }
  
  cout<<"Waiting for interrupt"<<endl;

  while (1){
	  WaitForSingleObject(Event, INFINITE);
	  cout<<"Got Interrupt"<<endl;
	  ResetEvent(Event);
  }
  
  return true;
}

bool testDisable_Interrupt(){
  TTCCANDeviceEx objEx;
  objEx.Open(0);

  UINT8 nCh=2;
  if (objEx.DisableInterrupt(nCh, RX0IE) != 1){
	  cout<<"DisableInterrupt error"<<endl;
	  return FALSE;
  }
  cout<<"Interrupt was disabled"<<endl;
  
  return true;
}


int _tmain(int argc, _TCHAR* argv[]){

	testRegister_Interrupt();
	testDisable_Interrupt();

	cin.get(); cin.get();
	return 0;
}

