
#ifndef _STD_INTERFACES_H
#define _STD_INTERFACES_H

/////////////////////////////////////////////////////////////////////////////
// ISharedObject

class ISharedObject
{
public:
  virtual BOOL Release() = 0;
};

/////////////////////////////////////////////////////////////////////////////
// IStatusTextManager

#ifdef _MFC_VER

class IStatusTextManager
{
public:
  virtual POSITION AddMessage(LPCTSTR lpszText) = 0;
  virtual void ModifyMessage(POSITION Pos, LPCTSTR lpszText) = 0;
  virtual void RemoveMessage() = 0;
};

#endif

/////////////////////////////////////////////////////////////////////////////
// ILongOperationSite

class ILongOperationSite
{
public:
  virtual void UpdatePercents(UINT nPercents);
  virtual void SetStateDescr(LPCTSTR lpszText);
  virtual void UpdateGUI();
};

#endif
